/****
 *
 * Exemplo: Esvaziamento do Buffer de Entrada
 *
 * Seo: 2.2
 *
 ****/

#include <stdio.h>

int LimpaBuffer(void)
{
   int carLido, /* Armazena cada caractere lido */
       nCarLidos = 0; /* Conta o nmero de */
                      /* caracteres lidos  */

      /* L e descarta cada caractere lido at    */
      /* encontrar '\n' ou getchar() retornar EOF */
   do {
      carLido = getchar(); /* L um caractere */
      ++nCarLidos; /* Mais um caractere foi lido */
   } while ((carLido != '\n') && (carLido != EOF));

      /* O ltimo caractere lido foi '\n' ou  */
      /* EOF e no deve ser considerado sobra */
   return nCarLidos - 1;
}

int main(void)
{
   int  umInt, outroInt, nValoresLidos;

   printf("\nDigite um valor inteiro: ");
   nValoresLidos = scanf("%d", &umInt);

      /* Verifica se scanf() retornou EOF.    */
      /* Se no for o caso, limpa o buffer.   */
      /* Se foi lido algum valor, apresenta-o. */
   if (nValoresLidos !=  EOF) {
      (void) LimpaBuffer();

      if (nValoresLidos) {
         printf("Valor lido: %d\n", umInt);
      }
   } else { /* scanf() retornou EOF */
      printf("\n\t>>> Ocorreu erro de leitura\n");
      return 1;
   }

   printf("\nDigite outro valor inteiro: ");
   nValoresLidos = scanf("%d", &outroInt);

      /* Verifica se scanf() retornou EOF */
   if (nValoresLidos ==  EOF) {
      printf("\n\t>>> Ocorreu erro de leitura\n");
      return 1;
   }

   if (nValoresLidos) {
      printf("Valor lido: %d\n", outroInt);
   }

   return 0;
}


/******************* Exemplo de Execuo ******************

Digite um valor inteiro: 123av
Valor lido: 123

Digite outro valor inteiro: 36
Valor lido: 36

**********************************************************/
