/****
 *
 * Exemplo: Estruturas como Parmetros de Funes
 *
 * Seo: 3.10
 *
 ****/

#include <stdio.h>

typedef  struct  {
            char  nome[30];
            int   dia, mes, ano;
         } tRegistro;

void ExibeRegistro1(tRegistro registro)
{
   printf("Nome: %s\n", registro.nome);
   printf( "Nascimento: %d/%d/%d\n", registro.dia,
           registro.mes, registro.ano );
}

void ExibeRegistro2(const tRegistro *ptrRegistro)
{
   printf("Nome: %s\n", ptrRegistro->nome);
   printf( "Nascimento: %d/%d/%d\n", ptrRegistro->dia,
           ptrRegistro->mes, ptrRegistro->ano );
}

int main(void)
{
   tRegistro pessoa = { "Jose da Silva", 12, 10, 1960};
   tRegistro *ptrPessoa = &pessoa;

   printf("\n\n***** Usando ExibeRegistro1() *****\n\n");
   ExibeRegistro1(pessoa);

   printf("\n\n***** Usando ExibeRegistro2() *****\n\n");
   ExibeRegistro2(&pessoa);

   printf("\n\n***** Usando ExibeRegistro1() *****\n\n");
   ExibeRegistro1(*ptrPessoa);

   printf("\n\n***** Usando ExibeRegistro2() *****\n\n");
   ExibeRegistro2(ptrPessoa);

   return 0;
}

/****************** Resultado do Programa ******************

***** Usando ExibeRegistro1() *****

Nome: Jose da Silva
Nascimento: 12/10/1960


***** Usando ExibeRegistro2() *****

Nome: Jose da Silva
Nascimento: 12/10/1960


***** Usando ExibeRegistro1() *****

Nome: Jose da Silva
Nascimento: 12/10/1960


***** Usando ExibeRegistro2() *****

Nome: Jose da Silva
Nascimento: 12/10/1960

***********************************************************/
