/****
 *
 * Ttulo: Fibonacci + Recurso = Ineficincia
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2015
 * ltima modificao: 16/04/2015
 *
 * Descrio: Mostra a ineficincia do clculo recursivo de
 *            nmeros de Fibonacci
 *
 * Entrada: No h
 *
 * Sada: Uma sequncia de chamadas recursivas
 *
 ****/

#include <stdio.h> /* printf() */

/****
 *
 * Fib(): Gera o nmero de Fibonacci de ordem n [i.e., o
 *        (n+1)-simo termo de uma sequncia de Fibonacci]
 *
 * Parmetros:
 *      n (entrada) - nmero de ordem do termo da sequncia
 *                    de Fibonacci que ser gerado
 *
 * Retorno: O nmero de Fibonacci gerado
 *
 * Observaes: Esta implementao recursiva tem propsito
 *              didtico apenas e NO deve ser imitada na
 *              prtica.
 *
 ****/
int Fib(int n)
{
   printf("Fib(%d)\t", n);

   if (n < 2)
      return n; /* Dois primeiros termos */

   return Fib(n - 2) + Fib(n - 1); /* Caso recursivo */
}

/****
 *
 * main(): Testa a funo Fib()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int f = Fib(6);

   printf("\nFibonacci(6) = %d\n", f);

   return 0;
}

/****************** Resultado do Programa *****************

Fib(6)  Fib(4)  Fib(2)  Fib(0)  Fib(1)  Fib(3)  Fib(1)  Fib(2)
Fib(0)  Fib(1)  Fib(5)  Fib(3)  Fib(1)  Fib(2)  Fib(0)  Fib(1)
Fib(4)  Fib(2)  Fib(0)  Fib(1)  Fib(3)  Fib(1)  Fib(2)  Fib(0)
Fib(1)

Fibonacci(6) = 8

**********************************************************/
