/****
 *
 * Ttulo: Exibindo-se em Frente e Verso
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2015
 * ltima modificao: 16/04/2015
 *
 * Descrio: Exibe este cdigo-fonte na tela de duas
 *            maneiras: (1) do incio para o final e
 *            (2) do final para o incio
 *
 * Entrada: Nada
 *
 * Sada: O contedo deste arquivo do incio para o
 *        final e do final para o incio
 *
 ****/

/*********************** Includes *************************/

#include <stdio.h>   /* Entrada e sada          */
#include <string.h>  /* Processamento de strings */
#include <stdlib.h>  /* Alocao dinmica        */

/***************** Definies de Funes ******************/

/****
 *
 * ExibeArquivoNaTelaRec(): Escreve um arquivo de texto na
 *                          tela recursivamente
 *
 * Parmetros:
 *      stream (entrada) - stream associado ao arquivo que se
 *                         pressupe estar aberto em modo que
 *                         permite leitura e com o apontador
 *                         de posio apontando para o
 *                         primeiro byte
 *
 * Retorno: Nada
 *
 ****/
void ExibeArquivoNaTelaRec(FILE *stream)
{
   if ( !feof(stream) && !ferror(stream) ) {
      putchar(fgetc(stream));
      ExibeArquivoNaTelaRec(stream);
   }
}

/****
 *
 * ExibeArquivoInvNaTelaRec(): Escreve recursivamente um arquivo
 *                             de texto invertido na tela
 *
 * Parmetros:
 *      stream (entrada) - stream associado ao arquivo que se
 *                         pressupe estar aberto em modo que
 *                         permite leitura e com o apontador
 *                         de posio apontando para o
 *                         primeiro byte
 *
 * Retorno: Nada
 *
 ****/
void ExibeArquivoInvNaTelaRec(FILE *stream)
{
   int c;

   c = fgetc(stream);

   if ( !feof(stream) && !ferror(stream) ) {
      ExibeArquivoInvNaTelaRec(stream);
   }

   putchar(c);
}

/****
 *
 * main(): Abre o prprio arquivo fonte e usa as funes
 *         ExibeArquivoNaTelaRec() e ExibeArquivoInvNaTelaRec()
 *         para apresentar seu contedo
 *
 * Parmetros: argc (entrada) - Nmero de argumentos de
 *                              linha de comando
 *             argv (entrada) - Array de strings presentes
 *                              na linha de comando quando
 *                              o programa  executado
 *
 * Retorno: Zero, se no ocorrer nenhum erro.
 *          Um valor diferente de zero em caso contrrio.
 *
 * Observao:
 *
 ****/
int main(int argc, char** argv)
{
   char *nome;
   FILE *stream;

      /* Tenta determinar o nome do arquivo fonte */
   if (strchr(*argv, '.')) { /* Arquivo parece   */
                             /* que tem extenso */
      *(strchr(*argv, '.') + 1) = 'c';
      *(strchr(*argv, '.') + 2) = '\0';
   } else {
         /* O arquivo no tem extenso. No se pode usar */
         /* o mesmo truque da parte if, pois causar     */
         /* corrupo de memria. Alocao dinmica     */
         /* necessria. O nmero mgico 3 representa os  */
         /* trs caracteres: '.' + 'c' + '\0'.           */
      nome = malloc(strlen(*argv) + 3);
      strcat(strcpy(nome, *argv), ".c");
   }

      /* Esgotou a capacidade de adivinhao do programa */
      /* Se no conseguir abrir o arquivo, desiste.      */
   if (!(stream = fopen(*argv, "r"))) {
      printf( "\nNao foi possivel abrir o aquivo: %s\n",
              *argv );
      return 1;
   }

      /* Exibe-se do incio para o final */
   ExibeArquivoNaTelaRec(stream);

      /* Faz o apontador de posio  */
      /* voltar para o primeiro byte */
   rewind(stream);

      /* Exibe-se do final para o incio */
   ExibeArquivoInvNaTelaRec(stream);

   return 0;
}

/****************** Resultado do Programa *****************

O cdigo-fonte deste programa apresentado na tela do
incio para o fim e do fim para o incio

**********************************************************/
