/****
 *
 * Ttulo: Nmeros Complexos como um Tipo de Dados
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Implementa o tipo de dados tComplexo que
 *            representa nmeros complexos munido das
 *            operaes: iniciao, soma e exibio na tela
 *
 * Entrada: No h
 *
 * Sada: O resultado da soma de dois nmeros complexos
 *        calculado de duas maneiras diferentes
 *
 ****/

#include <stdio.h>      /* printf() */
#include "Complexos1.h" /* Interface do tipo complexo */

/****
 *
 * main(): Testa operaes sobre nmeros complexos
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main (void)
{
   tComplexo c1 = IniciaComplexo(2, 3),
             c2 = IniciaComplexo(3, 2),
             c3;

   ExibeComplexo(c1);
   printf(" + ");
   ExibeComplexo(c2);
   printf(" = ");

   ExibeComplexo(SomaComplexos(c1, c2));

   c3.pReal = c1.pReal + c2.pReal;
   c3.pImaginaria = c1.pImaginaria + c2.pImaginaria;

   printf("\n\nSoma = %5.2f + %5.2fi\n", c3.pReal, c3.pImaginaria);

   return 0;
}

/****************** Resultado do Programa *****************

 2.00 +  3.00i +  3.00 +  2.00i =  5.00 +  5.00i

Soma =  5.00 +  5.00i

**********************************************************/
