/****
 *
 * Ttulo: Um Algoritmo com Estimativa O(n log n)
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Apresenta um algoritmo com Estimativa O(n log n)
 *
 * Entrada: Nenhuma
 *
 * Sada: v Resultado do Programa
 *
 ****/

#include <stdio.h> /* printf() */

/****
 *
 * Rodadas(): Esta funo no faz nada til. Ela apenas
 *            demonstra a implementao de um algoritmo
 *            com custo O(n log n)
 *
 * Parmetros: n (entrada) - o nmero de rodadas (o que
 *                           quer que isso signifique...)
 *
 * Retorno: Nada
 *
 ****/
void Rodadas(int n)
{
   int i, j;

   for (i = 1; i <= n; i++) {
      printf("\n\nRodada %d: ", i);

      j = n;

      while (j > 1) {
         j = j/2;
         printf("%d\t", j);
      }
   }
}

/****
 *
 * main(): Testa a funo F()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int n = 20;

   printf("\n\t*** Resultado ***");

   F(n);

   return 0;
}

/****************** Resultado do Programa *****************

        *** Resultado ***

Rodada 1: 10    5       2       1

Rodada 2: 10    5       2       1

Rodada 3: 10    5       2       1

Rodada 4: 10    5       2       1

Rodada 5: 10    5       2       1

Rodada 6: 10    5       2       1

Rodada 7: 10    5       2       1

Rodada 8: 10    5       2       1

Rodada 9: 10    5       2       1

Rodada 10: 10   5       2       1

Rodada 11: 10   5       2       1

Rodada 12: 10   5       2       1

Rodada 13: 10   5       2       1

Rodada 14: 10   5       2       1

Rodada 15: 10   5       2       1

Rodada 16: 10   5       2       1

Rodada 17: 10   5       2       1

Rodada 18: 10   5       2       1

Rodada 19: 10   5       2       1

Rodada 20: 10   5       2       1

**********************************************************/
