/****
 *
 * Ttulo: Invertendo Entradas 2
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2015
 * ltima modificao: 16/04/2015
 *
 * Descrio: Inverte os caracteres digitados pelo usurio usando pilha
 *
 * Entrada: Uma cadeia de caracteres introduzida pelo usurio
 *
 * Sada: A cadeia de caracteres invertida
 *
 ****/

#include <stdio.h>   /* Funes de Entrada/Sada  */
#include "Pilha.h"  /* Interface do tipo pilha implementada com array */

/****
 *
 * main(): Inverte os caracteres digitados pelo usurio usando pilha
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main (void)
{
   tPilhaIdx pilha;
   int    c;

   CriaPilhaIdx(&pilha);  /* Inicia a pilha */

   printf( "\n>>> Digite uma sequencia de caracteres "
           "\n>>> para o programa inverter: " );

   while ((c = getchar()) != '\n')
      EmpilhaIdx(c, &pilha);

   while (!PilhaIdxVazia(pilha))
      putchar( DesempilhaIdx(&pilha) );

   return 0;
}

/******************* Exemplo de Execuo ******************

>>> Digite uma sequencia de caracteres
>>> para o programa inverter: Roma
amoR

**********************************************************/
