#ifndef _Lista_H_
#define _Lista_H_

/***************** Constantes Simblicas ******************/

   /* Nmero mximo de caracteres num item */
#define MAX_ITEM      10
   /* Nmero mximo de elementos numa lista */
#define MAX_ELEMENTOS 20

/****************** Definies de Tipos *******************/

typedef char tItem[MAX_ITEM];

typedef struct {
           int   nElementos; /* Nmero de elementos na lista */
           tItem itens[MAX_ELEMENTOS]; /* Os elementos */
        } tLista;

/******************* Aluses de Funes *******************/

extern int EstaCheia(const tLista *lista);
extern int EstaVazia(const tLista *lista);
extern void ApresentaLista(const tLista *aLista);
extern void IniciaLista(tLista *lista);
extern int Comprimento(const tLista *lista);
extern char *ConsultaElemento(const tLista *lista, int pos);
extern void AlteraValor(tLista *lista, tItem valor, int pos);
extern void InsereElemento( tLista *lista, tItem elemento, int pos );
extern void AcrescentaElemento(tLista *lista, tItem elemento);
extern char *RemoveElemento(tLista *lista, int pos);

#endif
