/****
 *
 * Exemplo: Ponteiros para Funes
 *
 * Seo: 11.1
 *
 * Demonstra: Uso de ponteiros para funes
 *
 ****/

#include <stdlib.h>
#include <stdio.h>

extern int F1(double); /* Aluso da funo F1() */

int main(void)
{
   int  (*pf)(double); /* Ponteiro para funo que recebe */
                       /*  um parmetro do tipo double   */
                       /* e retorna um valor int         */

   pf = F1; /* pf passa a apontar para a funo F1() */

   pf = F1(2.5); /* Ilegal, pois F1()  uma chamada de */
                 /* funo que retorna int. Portanto,  */
                 /* se est tentando atribuir um valor */
                 /* do tipo int a um ponteiro, o que   */
                 /* no  permitido.                   */

   pf = &F1(2.5); /* Ilegal, pois se est tentando obter  */
                  /* o endereo do valor retornado por F1 */

   pf = &F1;  /* Estritamente falando,  incorreto, pois */
              /* se est tentando obter o endereo de um */
              /* endereo, mas compiladores ISO no iro */
              /* considerar isto um erro. Eles           */
              /* simplesmente ignoraro o operador &.    */

   return 0;
}
