/****
 *
 * Ttulo: Pilha Genrica
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 01/05/2013
 * ltima modificao: 01/05/2013
 *
 * Descrio: Testa operaes com pilha genrica
 *
 * Entrada: No h
 *
 * Sada: Informaes referentes a operaes com uma pilha
 *        genrica
 *
 ****/

/*********************** Includes *************************/

#include <stdio.h>  /* Entrada e Sada */
#include "PilhaG.h" /* Pilha genrica  */

/********************* Funo main() **********************/

/****
 *
 * main():
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero, se no ocorrer nenhum erro.
 *          Um valor diferente de zero em caso contrrio.
 *
 ****/
int main(void)
{
   int       item;
   tPilhaGen pilhaInt;

      /* Cria uma plha de elementos do tipo int */
   CriaPilhaG(&pilhaInt, sizeof(int));

      /* Empilha 10 elementos na pilha */
   for (item = 0; item < 10; item++) {
      EmpilhaG(&pilhaInt, &item);
      printf("\nEmpilhado: %d", item);
   }

      /* Apresenta o elemento no topo da pilha */
   printf( "\n\nElemento no topo da pilha: %d\n\n",
           *(int *)ElementoTopoG(&pilhaInt, &item) );

      /* Desemplilha todos os elementos  */
      /* da pilha e apresenta-os na tela */
   while (!PilhaVaziaG(&pilhaInt)) {
      DesempilhaG(&pilhaInt, &item);
      printf("Desempilhado: %d\n", item);
   }

      /* Libera espao ocupado pelo continer da pilha */
   DestroiPilhaG(&pilhaInt);

   return 0;
}

/****************** Resultado do Programa ******************

Empilhado: 0
Empilhado: 1
Empilhado: 2
Empilhado: 3
Empilhado: 4
Empilhado: 5
Empilhado: 6
Empilhado: 7
Empilhado: 8
Empilhado: 9

Elemento no topo da pilha: 9

Desempilhado: 9
Desempilhado: 8
Desempilhado: 7
Desempilhado: 6
Desempilhado: 5
Desempilhado: 4
Desempilhado: 3
Desempilhado: 2
Desempilhado: 1
Desempilhado: 0

***********************************************************/
