/****
 *
 * Ttulo: Usando bsearch() e qsort()
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Determina se um nmero inteiro positivo  primo
 *
 * Entrada: Valores inteiros positivos ou zero para encerrar o programa
 *
 * Sada: Uma mensagem indicando se o nmero  primo ou no
 *
 ****/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/****
 *
 * Compara1(): compara dois strings
 *
 * Parmetros:
 *      p1 (entrada) - ponteiro para o primeiro strings
 *      p2 (entrada) - ponteiro para o segundo strings
 *
 * Retorno:  0, se os strings forem iguais
 *           1, se o primeiro string for maior
 *          -1, se o primeiro string for menor
 *
 ****/
int Compara1(const void *s1, const void *s2)
{
   const char *str1 = *(char **)s1;
   const char *str2 = *(char **)s2;

   return strcmp(str1, str2);
}

/****
 *
 * Compara2(): compara dois strings
 *
 * Parmetros:
 *      p1 (entrada) - ponteiro para o primeiro strings
 *      p2 (entrada) - ponteiro para o segundo strings
 *
 * Retorno:  0, se os strings forem iguais
 *           1, se o primeiro string for maior
 *          -1, se o primeiro string for menor
 *
 ****/
int Compara2(const void *s1, const void *s2)
{
   return strcmp(*(char **)s1, *(char **)s2);
}

int ComparaErrado1(const void *p1, const void *p2)
{
   const char *e1 = (const char *)p1;
   const char *e2 = (const char *)p2;

   return *e1 - *e2;
}

int ComparaErrado2(const void *p1, const void *p2)
{
   const char *e1 = (const char *)p1;
   const char *e2 = (const char *)p2;

   return strcmp(e1, e2);
}

/****
 *
 * main(): Testa a funo qsort()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   char *timao[] = { "Neuer", "Lahm", "Boateng", "Hummels",
                     "Howedes", "Schweinsteiger", "Khedira",
                     "Kroos", "Ozil", "Muller", "Klose" };
   int  i,
        n = sizeof(timao)/sizeof(timao[0]);

   qsort( timao, n, sizeof(timao[0]), ComparaErrado2 );

   for (i = 0; i < n; i++)
      printf("%s\n", timao[i]);

   return 0;
}

/****************** Resultado do Programa *****************

Boateng
Howedes
Hummels
Khedira
Klose
Kroos
Lahm
Muller
Neuer
Ozil
Schweinsteiger

**********************************************************/

