/****
 *
 * Arquivo Arvore.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo Arvore1
 *
 ****/

#ifndef _Arvore_H_
#define _Arvore_H_

/****************** Definies de Tipos *******************/

typedef struct noArvore {
           struct noArvore *esquerda;
           char             conteudo;
           struct noArvore *direita;
        } tNoArvore, *tArvore;

typedef void (*tOperacao) (char);

/************************* Aluses ************************/

extern tArvore ConstroiNo(char item);
extern void FilhoEsquerda(tNoArvore *pNo, char item);
extern void FilhoDireita(tNoArvore *pNo, char item);
extern void Prefixo(tArvore arvore, tOperacao op);
extern void Infixo(tArvore arvore, tOperacao op);
extern void Sufixo(tArvore arvore, tOperacao op);
extern void Exibe(tArvore arvore, tOperacao fImpressao);
extern void DestroiArvoreBin(tArvore arvore);

#endif
