/****
 *
 * Ttulo: Filas
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: Testa as operaes sobre filas encadeadas
 *
 * Entrada: No h
 *
 * Sada: Resultados de operaes sobre filas
 *
 ****/

#include <stdio.h> /* Funes de Entrada/Sada           */
#include "Fila.h" /* Declaraes do tipo fila encadeada */
#include "Arvore.h" /* Declaraes do tipo fila encadeada */

void Misteriosa(tArvore ptrArvore)
{
   tFila fila;

   CriaFila(&fila);

   Acrescenta(&fila, &ptrArvore);

   while (!FilaVazia(&fila)) {
      ptrArvore = Retira(&fila);

      if (ptrArvore) {
         putchar(ptrArvore->conteudo);
         Acrescenta(&fila, &ptrArvore->esquerda);
         Acrescenta(&fila, &ptrArvore->direita);
      }
   }
}

/****
 *
 * main(): Testa as operaes sobre filas.
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero, se no ocorrer nenhum erro.
 *          Um valor diferente de zero em caso contrrio.
 *
 ****/
int main (void)
{
   tArvore arvore;

   arvore = ConstroiNo('A'); /* Primeiro nvel (raiz) */

      /* Construo do segundo nvel da rvore */
   FilhoEsquerda(arvore, 'B'); /* Constri filho esquerdo */
   FilhoDireita(arvore, 'C');  /* Constri filho direito  */

      /* Construo do terceiro nvel da rvore */
   FilhoEsquerda(arvore->esquerda, 'D');
   FilhoEsquerda(arvore->direita, 'E');
   FilhoDireita(arvore->direita, 'F');

   Misteriosa(arvore);

   return 0;
}

/************* Resultado da Execuo do Programa *************

Elemento na frente: a
Retirado: a
Retirado: b
Retirado: c
Retirado: a
Retirado: b
Retirado: c
Retirado: d
Retirado: e
Retirado: f
Retirado: g
Retirado: h
Retirado: i
Retirado: j
Retirado: k
Retirado: l
Retirado: m
Retirado: n
Retirado: o
Retirado: p
Retirado: q
Retirado: r
Retirado: s
Retirado: t
Retirado: u
Retirado: v
Retirado: w
Retirado: x
Retirado: y
Retirado: z


**************************************************************/
