/****
 *
 * Arquivo: Arvore.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo Arvore2
 *
 ****/

#ifndef _Arvore_H_
#define _Arvore_H_

/****************** Definies de Tipos *******************/

typedef char tConteudo;

typedef struct  rotNoArvoreBin {
           struct rotNoArvoreBin *esquerda;
           tConteudo              conteudo;
           struct rotNoArvoreBin *direita;
        } tNoArvoreBin, *tArvoreBin;

typedef void (*tOperacao) (tConteudo);

/************************* Aluses ************************/

extern tArvoreBin ConstroiNoArvoreBin(tConteudo item);
extern void FilhoEsquerdo(tNoArvoreBin *pNo, tConteudo item);
extern void FilhoDireito(tNoArvoreBin *pNo, tConteudo item);
extern void CaminhamentoPrefixo(tArvoreBin arvore, tOperacao op);
extern void ExibeArvoreBin(tArvoreBin arvore, tOperacao fImpressao);
extern int AlturaArvoreBin(tArvoreBin p);
extern int SaoSemelhantesArvoresBin( tArvoreBin arvore1, tArvoreBin arvore2 );
extern tArvoreBin CopiaArvoreBin(tArvoreBin arvore);
extern int NivelDeNoArvoreBin(tArvoreBin arvore, tArvoreBin pNo);
extern tArvoreBin CriaArvoreFibonacci(int n);
extern int NumeroDeNos(tArvoreBin arvore);
extern void DestroiArvoreBin(tArvoreBin arvore);

#endif
