/****
 *
 * Arquivo Arvore1.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo Arvore1
 *
 ****/

#ifndef _Arvore_H_
#define _Arvore_H_

/****************** Definies de Tipos *******************/

typedef char tConteudo;

typedef struct rotNoArvoreBin {
           struct rotNoArvoreBin *esquerda;
           tConteudo              conteudo;
           struct rotNoArvoreBin *direita;
        } tNoArvoreBin, *tArvoreBin;

typedef void (*tOperacao) (tConteudo);

/************************* Aluses ************************/

extern tArvoreBin ConstroiNoArvoreBin(tConteudo item);
extern void FilhoEsquerdo(tNoArvoreBin *pNo, tConteudo item);
extern void FilhoDireito(tNoArvoreBin *pNo, tConteudo item);
extern void CaminhamentoInfixo(tArvoreBin arvore, tOperacao op);
extern void CaminhamentoInfixo2(tArvoreBin arvore, tOperacao op);
extern void ExibeArvoreBin(tArvoreBin arvore, tOperacao fImpressao);
extern void DestroiArvoreBin(tArvoreBin arvore);

#endif
