/****
 *
 * Arquivo: ArvoreC.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo ArvoreC (rvore costurada)
 *
 ****/

#ifndef _ArvoreC_H_
#define _ArvoreC_H_

/****************** Definies de Tipos *******************/

typedef  char tConteudo;

typedef enum {SIM, NAO} tCostura;

typedef struct rotNoArvoreCost {
           struct rotNoArvoreCost *esquerda;
           tConteudo               conteudo;
           struct rotNoArvoreCost *direita;
           tCostura                costura;
        } tNoArvoreCost, *tArvoreCost;

/************************* Aluses ************************/

typedef void (*tOperacao) (tConteudo);

extern tArvoreCost ConstroiNoArvoreCost(tConteudo item);
extern void FilhoEsquerdoCost(tNoArvoreCost *pNo, tConteudo item);
extern void FilhoDireitoCost(tNoArvoreCost *pNo, tConteudo item);
extern void CaminhamentoInfixoCost(tArvoreCost arvore, tOperacao op);
extern void CaminhamentoPrefixoCost(tArvoreCost arvore, tOperacao op);
extern void CaminhamentoSufixoCost(tArvoreCost arvore, tOperacao op);
extern void ExibeArvoreCost(tArvoreCost arvore, tOperacao fImpressao);

#endif
